# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from kvh_geo_fog_3d_msgs/KvhGeoFog3DNorthSeekingInitStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class KvhGeoFog3DNorthSeekingInitStatus(genpy.Message):
  _md5sum = "88b6ae501be454f43fc2dc643e776ea1"
  _type = "kvh_geo_fog_3d_msgs/KvhGeoFog3DNorthSeekingInitStatus"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """############################
# North Seeking Initialisation status message for
# KVH GEO FOG 3D north seeking Initialisation status packet
############################

#
# ROS message header.
# header.stamp specifies the ROS time for this measurement. Satellite
# time is reported as unix_time_s and unix_time_us.
#
Header header

#
# North Seeking initialisation flags.
# Bits:
#   0 - North seeking initialisation complete
#   1 - North seeking initialisation cannot start because postion unknown
#   2 - North seeking initialisation paused due to excessive rolling
#   3 - North seeking initialisation pauded due to excessive pitching
#   4 - North seeking initialisation paused due to excessive movement
#
uint16 flags

#
# Quadrant 1 data collection progress in percent
#
uint8 quadrant_1_data_per

#
# Quadrant 2 data collection progress in percent
#
uint8 quadrant_2_data_per

#
# Quadrant 3 data collection progress in percent
#
uint8 quadrant_3_data_per

#
# Quadrant 4 data collection progress in percent 
#
uint8 quadrant_4_data_per

#
# Current rotation angle in radians
# -pi/4 to pi/4 - quadrant 1
# pi/4 to 3pi/3 - quadrant 2
# -3pi/4 to 3pi/4 - quadrant 3
# -3pi/4 to -pi/4 - quadrant 4
float32 current_rotation_angle_rad

#
# Current gyroscope bias solution X (rad/s)
#
float32 current_gyro_bias_sol_x_rad_s

#
# Current gyroscope bias solution Y (rad/s)
#
float32 current_gyro_bias_sol_y_rad_s

#
# Current gyroscope bias solution z (rad/s)
#
float32 current_gyro_bias_sol_z_rad_s

#
# Current gyroscope bias solution error (%)
#
float32 current_gyro_bias_sol_error_per

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id
"""
  __slots__ = ['header','flags','quadrant_1_data_per','quadrant_2_data_per','quadrant_3_data_per','quadrant_4_data_per','current_rotation_angle_rad','current_gyro_bias_sol_x_rad_s','current_gyro_bias_sol_y_rad_s','current_gyro_bias_sol_z_rad_s','current_gyro_bias_sol_error_per']
  _slot_types = ['std_msgs/Header','uint16','uint8','uint8','uint8','uint8','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,flags,quadrant_1_data_per,quadrant_2_data_per,quadrant_3_data_per,quadrant_4_data_per,current_rotation_angle_rad,current_gyro_bias_sol_x_rad_s,current_gyro_bias_sol_y_rad_s,current_gyro_bias_sol_z_rad_s,current_gyro_bias_sol_error_per

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(KvhGeoFog3DNorthSeekingInitStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.flags is None:
        self.flags = 0
      if self.quadrant_1_data_per is None:
        self.quadrant_1_data_per = 0
      if self.quadrant_2_data_per is None:
        self.quadrant_2_data_per = 0
      if self.quadrant_3_data_per is None:
        self.quadrant_3_data_per = 0
      if self.quadrant_4_data_per is None:
        self.quadrant_4_data_per = 0
      if self.current_rotation_angle_rad is None:
        self.current_rotation_angle_rad = 0.
      if self.current_gyro_bias_sol_x_rad_s is None:
        self.current_gyro_bias_sol_x_rad_s = 0.
      if self.current_gyro_bias_sol_y_rad_s is None:
        self.current_gyro_bias_sol_y_rad_s = 0.
      if self.current_gyro_bias_sol_z_rad_s is None:
        self.current_gyro_bias_sol_z_rad_s = 0.
      if self.current_gyro_bias_sol_error_per is None:
        self.current_gyro_bias_sol_error_per = 0.
    else:
      self.header = std_msgs.msg.Header()
      self.flags = 0
      self.quadrant_1_data_per = 0
      self.quadrant_2_data_per = 0
      self.quadrant_3_data_per = 0
      self.quadrant_4_data_per = 0
      self.current_rotation_angle_rad = 0.
      self.current_gyro_bias_sol_x_rad_s = 0.
      self.current_gyro_bias_sol_y_rad_s = 0.
      self.current_gyro_bias_sol_z_rad_s = 0.
      self.current_gyro_bias_sol_error_per = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_H4B5f().pack(_x.flags, _x.quadrant_1_data_per, _x.quadrant_2_data_per, _x.quadrant_3_data_per, _x.quadrant_4_data_per, _x.current_rotation_angle_rad, _x.current_gyro_bias_sol_x_rad_s, _x.current_gyro_bias_sol_y_rad_s, _x.current_gyro_bias_sol_z_rad_s, _x.current_gyro_bias_sol_error_per))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 26
      (_x.flags, _x.quadrant_1_data_per, _x.quadrant_2_data_per, _x.quadrant_3_data_per, _x.quadrant_4_data_per, _x.current_rotation_angle_rad, _x.current_gyro_bias_sol_x_rad_s, _x.current_gyro_bias_sol_y_rad_s, _x.current_gyro_bias_sol_z_rad_s, _x.current_gyro_bias_sol_error_per,) = _get_struct_H4B5f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_H4B5f().pack(_x.flags, _x.quadrant_1_data_per, _x.quadrant_2_data_per, _x.quadrant_3_data_per, _x.quadrant_4_data_per, _x.current_rotation_angle_rad, _x.current_gyro_bias_sol_x_rad_s, _x.current_gyro_bias_sol_y_rad_s, _x.current_gyro_bias_sol_z_rad_s, _x.current_gyro_bias_sol_error_per))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 26
      (_x.flags, _x.quadrant_1_data_per, _x.quadrant_2_data_per, _x.quadrant_3_data_per, _x.quadrant_4_data_per, _x.current_rotation_angle_rad, _x.current_gyro_bias_sol_x_rad_s, _x.current_gyro_bias_sol_y_rad_s, _x.current_gyro_bias_sol_z_rad_s, _x.current_gyro_bias_sol_error_per,) = _get_struct_H4B5f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_H4B5f = None
def _get_struct_H4B5f():
    global _struct_H4B5f
    if _struct_H4B5f is None:
        _struct_H4B5f = struct.Struct("<H4B5f")
    return _struct_H4B5f
