# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from kvh_geo_fog_3d_msgs/KvhGeoFog3DSatellites.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class KvhGeoFog3DSatellites(genpy.Message):
  _md5sum = "e7f6cf68f4324d6c18687862aad81655"
  _type = "kvh_geo_fog_3d_msgs/KvhGeoFog3DSatellites"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """###############################################
# Satellites message for the KVH GEO FOG 3D satellites packet
###############################################

#
# ROS message header.
# header.stamp specifies the ROS time for this measurement. Satellite
# time is reported as unix_time_s and unix_time_us.
#
Header header

#
# Horizontal dilution of precision (HDOP). Describes
# the strength of current satellite configuration.
#
float32 hdop

#
# Vertical dilution of precision (VDOP). Describes
# the strength of current satellite configuration.
#
float32 vdop

#
# Number of total satellites in sight
#
uint8 gps_satellites

#
# Number of glonass satellites in sight
#
uint8 glonass_satellites

#
# Number of beidou satellites in sight
#
uint8 beidou_satellites

#
# Number of galileo satellites in sight
#
uint8 galileo_satellites

#
# Number of sbas satellites in sight
#
uint8 sbas_satellites
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id
"""
  __slots__ = ['header','hdop','vdop','gps_satellites','glonass_satellites','beidou_satellites','galileo_satellites','sbas_satellites']
  _slot_types = ['std_msgs/Header','float32','float32','uint8','uint8','uint8','uint8','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,hdop,vdop,gps_satellites,glonass_satellites,beidou_satellites,galileo_satellites,sbas_satellites

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(KvhGeoFog3DSatellites, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.hdop is None:
        self.hdop = 0.
      if self.vdop is None:
        self.vdop = 0.
      if self.gps_satellites is None:
        self.gps_satellites = 0
      if self.glonass_satellites is None:
        self.glonass_satellites = 0
      if self.beidou_satellites is None:
        self.beidou_satellites = 0
      if self.galileo_satellites is None:
        self.galileo_satellites = 0
      if self.sbas_satellites is None:
        self.sbas_satellites = 0
    else:
      self.header = std_msgs.msg.Header()
      self.hdop = 0.
      self.vdop = 0.
      self.gps_satellites = 0
      self.glonass_satellites = 0
      self.beidou_satellites = 0
      self.galileo_satellites = 0
      self.sbas_satellites = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2f5B().pack(_x.hdop, _x.vdop, _x.gps_satellites, _x.glonass_satellites, _x.beidou_satellites, _x.galileo_satellites, _x.sbas_satellites))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.hdop, _x.vdop, _x.gps_satellites, _x.glonass_satellites, _x.beidou_satellites, _x.galileo_satellites, _x.sbas_satellites,) = _get_struct_2f5B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2f5B().pack(_x.hdop, _x.vdop, _x.gps_satellites, _x.glonass_satellites, _x.beidou_satellites, _x.galileo_satellites, _x.sbas_satellites))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.hdop, _x.vdop, _x.gps_satellites, _x.glonass_satellites, _x.beidou_satellites, _x.galileo_satellites, _x.sbas_satellites,) = _get_struct_2f5B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2f5B = None
def _get_struct_2f5B():
    global _struct_2f5B
    if _struct_2f5B is None:
        _struct_2f5B = struct.Struct("<2f5B")
    return _struct_2f5B
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
