// Auto-generated. Do not edit!

// (in-package kvh_geo_fog_3d_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class KvhGeoFog3DLocalMagneticField {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.loc_mag_field_x_mG = null;
      this.loc_mag_field_y_mG = null;
      this.loc_mag_field_z_mG = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('loc_mag_field_x_mG')) {
        this.loc_mag_field_x_mG = initObj.loc_mag_field_x_mG
      }
      else {
        this.loc_mag_field_x_mG = 0.0;
      }
      if (initObj.hasOwnProperty('loc_mag_field_y_mG')) {
        this.loc_mag_field_y_mG = initObj.loc_mag_field_y_mG
      }
      else {
        this.loc_mag_field_y_mG = 0.0;
      }
      if (initObj.hasOwnProperty('loc_mag_field_z_mG')) {
        this.loc_mag_field_z_mG = initObj.loc_mag_field_z_mG
      }
      else {
        this.loc_mag_field_z_mG = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type KvhGeoFog3DLocalMagneticField
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [loc_mag_field_x_mG]
    bufferOffset = _serializer.float32(obj.loc_mag_field_x_mG, buffer, bufferOffset);
    // Serialize message field [loc_mag_field_y_mG]
    bufferOffset = _serializer.float32(obj.loc_mag_field_y_mG, buffer, bufferOffset);
    // Serialize message field [loc_mag_field_z_mG]
    bufferOffset = _serializer.float32(obj.loc_mag_field_z_mG, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type KvhGeoFog3DLocalMagneticField
    let len;
    let data = new KvhGeoFog3DLocalMagneticField(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [loc_mag_field_x_mG]
    data.loc_mag_field_x_mG = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [loc_mag_field_y_mG]
    data.loc_mag_field_y_mG = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [loc_mag_field_z_mG]
    data.loc_mag_field_z_mG = _deserializer.float32(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    return length + 12;
  }

  static datatype() {
    // Returns string type for a message object
    return 'kvh_geo_fog_3d_msgs/KvhGeoFog3DLocalMagneticField';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '31240c217318a807e157bacb88ee7714';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    ############################
    # Local magnetic field message for KVH GEO FOG 3D local magnetic field packet
    ############################
    
    #
    # ROS message header.
    # header.stamp specifies the ROS time for this measurement. Satellite
    # time is reported as unix_time_s and unix_time_us.
    #
    Header header
    
    #
    # Local magnetic field X (mG)
    #
    float32 loc_mag_field_x_mG
    
    #
    # Local magnetic field Y (mG)
    #
    float32 loc_mag_field_y_mG
    
    #
    # Local magnetic field Z (mG)
    float32 loc_mag_field_z_mG
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new KvhGeoFog3DLocalMagneticField(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.loc_mag_field_x_mG !== undefined) {
      resolved.loc_mag_field_x_mG = msg.loc_mag_field_x_mG;
    }
    else {
      resolved.loc_mag_field_x_mG = 0.0
    }

    if (msg.loc_mag_field_y_mG !== undefined) {
      resolved.loc_mag_field_y_mG = msg.loc_mag_field_y_mG;
    }
    else {
      resolved.loc_mag_field_y_mG = 0.0
    }

    if (msg.loc_mag_field_z_mG !== undefined) {
      resolved.loc_mag_field_z_mG = msg.loc_mag_field_z_mG;
    }
    else {
      resolved.loc_mag_field_z_mG = 0.0
    }

    return resolved;
    }
};

module.exports = KvhGeoFog3DLocalMagneticField;
